package com.mobvcasting.mmmsmessaging;

import processing.core.*;

import java.io.IOException;

import javax.microedition.io.Connector;
import javax.wireless.messaging.MessageConnection;
import javax.wireless.messaging.MultipartMessage;
import javax.wireless.messaging.MessagePart;

public class MMMSMessaging
{
	
	PMIDlet pmidlet;
	
	public MMMSMessaging(PMIDlet pmidlet)
	{
		this.pmidlet = pmidlet;
	}
		
	public void sendMMS(String to, String subject, String body, byte[] attachmentBytes, String attachmentMimeType, String attachmentFilename)
	{
		//String appID = pmidlet.getAppProperty("MMS-ApplicationID");
		String address = "mms://" + to;
		//String address = "mms://vanevery@walking-productions.com";
		//String address = "mms://7188096659:" + appID;
		
		MessageConnection mmsconn = null;
		try
		{
			mmsconn = (MessageConnection) Connector.open(address);
			MultipartMessage mmmessage = (MultipartMessage) mmsconn.newMessage(
						MessageConnection.MULTIPART_MESSAGE
					);
			mmmessage.setAddress(address);

			byte[] bodyBytes = body.getBytes("UTF-8");
			MessagePart textMessagePart = new MessagePart(
					bodyBytes, 0, bodyBytes.length, "text/plain", "id" + 0, "body", "UTF-8");
			
			MessagePart imageMessagePart = new MessagePart(
					attachmentBytes, 0, attachmentBytes.length, attachmentMimeType, "id" + 1, attachmentFilename, null);

			mmmessage.addMessagePart(textMessagePart);
			mmmessage.addMessagePart(imageMessagePart);
						
			mmmessage.setSubject(subject);
			mmsconn.send(mmmessage);
			
			mmsconn.close();
		}
		catch (Exception e)
		{
			throw new RuntimeException(e.getMessage());			
		}

		if (mmsconn != null)
		{
			try
			{
				mmsconn.close();
			}
			catch (IOException ioe)
			{
				throw new RuntimeException(ioe.getMessage());
			}
		}		
	}
}